﻿Option Explicit On
Option Strict On
Imports PluginAPI
Imports System.Xml.Serialization
Imports System.IO
Imports System.IO.MemoryMappedFiles
Imports System.Runtime.InteropServices
Imports System.Math

Public Class Plugin
    Implements IPlugin
    '//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    '///                            SimTools Plugin - Edit the Setting below to provide support for you favorite game!                              ///
    '//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////
    '/// Per Game Settings - Change for Each Game ///
    '////////////////////////////////////////////////
    Private Const _PluginAuthorsName As String = "value1/yobuddy"
    Private Const _GameName As String = "rFactor" 'The displayed Name for this Game. (DLL_Name ==> "Live for Speed.dll")
    Private Const _ProcessName As String = "rFactor" 'Process_Name without the (".exe") for this game. Multiple Names Possible - ("LFS,notepad")
    Private Const _Port As String = "4123" 'Your Sending/Recieving UDP Port for this game - DEFAULT PORT 4123

    '////////////////////////////////////////////////
    '///           Memory Map Variables           ///
    '////////////////////////////////////////////////
    Private Const _Is_MemoryMap As Boolean = True 'Is a MemoryMap file Required for this game?
    Private Const _MMF_Name As String = "SimToolsrFactor" 'Set if using a Memory Map File - EXAMPLE("$gtr2$")
    '////////////////////////////////////////////////
    '///           MemoryHook Variables           ///
    '////////////////////////////////////////////////   
    Private Const _Is_MemoryHook As Boolean = False 'Is a Memory Hook Required for this game? 
    Private Const _MemHook_Roll As UInteger = 0 'Not Used = 0
    Private Const _MemHook_Pitch As UInteger = 0
    Private Const _MemHook_Heave As UInteger = 0
    Private Const _MemHook_Yaw As UInteger = 0
    Private Const _MemHook_Sway As UInteger = 0
    Private Const _MemHook_Surge As UInteger = 0
    Private Const _MemHook_Extra1 As UInteger = 0
    Private Const _MemHook_Extra2 As UInteger = 0
    Private Const _MemHook_Extra3 As UInteger = 0
    '////////////////////////////////////////////////
    '///    DOFs Used for Output for this Game    ///
    '////////////////////////////////////////////////
    Private Const _DOF_Support_Roll As Boolean = True
    Private Const _DOF_Support_Pitch As Boolean = True
    Private Const _DOF_Support_Heave As Boolean = True
    Private Const _DOF_Support_Yaw As Boolean = True
    Private Const _DOF_Support_Sway As Boolean = True
    Private Const _DOF_Support_Surge As Boolean = True
    Private Const _DOF_Support_Extra1 As String = "" 'Blank = False
    Private Const _DOF_Support_Extra2 As String = "" '"" = Not Used
    Private Const _DOF_Support_Extra3 As String = "" 'ADD THE FORCE NAME HERE
    '/////////////////////////////////////////////////
    '///       GameDash - Dash Board Support       ///
    '/////////////////////////////////////////////////
    Private Const _Is_DashBoard As Boolean = True 'Enable the DashBoard Output System?
    'EXAMPLES OF DASHOUTPUT (all variables are strings) - 20 DASH OUTPUTS MAX!!!
    'Use the Variables with either Process_PacketRecieved, Process_MemoryHook or Process_MemoryMap.
    'Variable = (Action, Value) as String
    'Dash_1_Output = "Speed," & Speed_Value.ToString
    'Dash_2_Output = "Rpm," & RPM_Value.ToString
    'Dash_3_Output = "Gear," & Gear_Value.ToString
    '...
    'Dash_20_Output = "Gear," & OUTPUT_VALUE_HERE.ToString
    '////////////////////////////////////////////////
    'MMF file
    Public mmf As MemoryMappedFile
    'MMF acessor
    Public mmvs As MemoryMappedViewStream
    Public OldTime As Date = Now

    'Used by GameManager when the Game Starts.
    Public Sub StartupCommands() Implements IPlugin.StartupCommands
        'DO SOMETHING HERE AT GAME START!
    End Sub

    'Used by GameMnnager when the Game Stops.
    Public Sub ShutDownCommands() Implements IPlugin.ShutDownCommands
        'DO SOMETHING HERE AT GAME START!
        mmvs.Dispose()
        mmf.Dispose()
    End Sub

    'Used by GameManager to Process a MemoryHook.
    Public Sub Process_MemoryHook() Implements IPlugin.Process_MemoryHook
        'DO SOMETHING HERE AT GAME START!
    End Sub

    'Used by GameManager to Process a MemoryMap.
    Public SimTele As TelemInfoV2
    Public SimScoring As ScoringInfoV2
    Public vehicleScore As VehicleScoringInfoV2

    Public Sub Process_MemoryMap() Implements IPlugin.Process_MemoryMap
        'DO SOMETHING HERE AT GAME START!
        ' read shared memory

        Const sSize As Int32 = 492 'Marshal.SizeOf(ScoringInfoV2)
        Const tSize As Int32 = 780 'Marshal.SizeOf(TelemInfoV2)
        Const vSize As Int32 = 428 'Marshal.SizeOf(VehicleScoringInfoV2)
        Const radsToDeg As Single = 57.296F

        Dim sBytes(sSize) As Byte 'Size of ScoringInfoV2
        Dim tBytes(tSize) As Byte 'Size of TelemInfoV2
        Dim vbytes(vSize) As Byte  'Size of VehicleScoringInfoV2

        Try
            ' open mmf
            mmf = MemoryMappedFile.OpenExisting(_MMF_Name)
            ' create acessor
            mmvs = mmf.CreateViewStream(0, 0, MemoryMappedFileAccess.Read)
            ' get size of structure

            mmvs.Read(tBytes, 0, tSize)
            ' copy byte array into structure
            Dim ptr As New GCHandle
            ptr = GCHandle.Alloc(tBytes, GCHandleType.Pinned)
            SimTele = CType(Marshal.PtrToStructure(ptr.AddrOfPinnedObject, GetType(TelemInfoV2)), TelemInfoV2)

            mmvs.Read(sBytes, 0, sSize)
            ' copy byte array into structure
            ptr = GCHandle.Alloc(sBytes, GCHandleType.Pinned)
            SimScoring = CType(Marshal.PtrToStructure(ptr.AddrOfPinnedObject, GetType(ScoringInfoV2)), ScoringInfoV2)

            Dim foundcar As Boolean = False
            Dim i As Int32 = 0
            While i < 99 And Not foundcar
                mmvs.Position = sSize + tSize + i * vSize
                mmvs.Read(vbytes, 0, vSize)
                Dim ptr2 As New GCHandle
                ptr2 = GCHandle.Alloc(vbytes, GCHandleType.Pinned)
                vehicleScore = CType(Marshal.PtrToStructure(ptr2.AddrOfPinnedObject, GetType(VehicleScoringInfoV2)), VehicleScoringInfoV2)
                If vehicleScore.mIsPlayer = 1 Then
                    foundcar = True
                End If
                i = i + 1
            End While

            'assign values - clip very small values
            Dim RadtoDeg As Double = 45.0 / Atan(1)
            Dim pitch As Single = -CSng(Atan2(-SimTele.mOriY.z, Sqrt((-SimTele.mOriX.z * -SimTele.mOriX.z) + (-SimTele.mOriZ.z * -SimTele.mOriZ.z)))) * radsToDeg
            Dim yaw As Single = -CSng(Atan2(SimTele.mOriX.z, SimTele.mOriZ.z)) * radsToDeg
            Dim roll As Single = CSng(Atan2(SimTele.mOriY.x, Sqrt((SimTele.mOriX.x * SimTele.mOriX.x) + (SimTele.mOriZ.x * SimTele.mOriZ.x)))) * radsToDeg
            Dim speed As Single = CSng(Sqrt(SimTele.mLocalVel.x * SimTele.mLocalVel.x + SimTele.mLocalVel.y * SimTele.mLocalVel.y + SimTele.mLocalVel.z * SimTele.mLocalVel.z))
            Dim ShiftUp As Boolean
            Dim ShiftDown As Boolean
            Dim TireDamage As Boolean
            Dim BrakeOverheat As Boolean

            Roll_MemMap = roll
            Pitch_MemMap = pitch
            Heave_MemMap = SimTele.mLocalAccel.y
            Yaw_MemMap = yaw
            Sway_MemMap = -SimTele.mLocalAccel.x
            Surge_MemMap = -SimTele.mLocalAccel.z

            If SimTele.mEngineRPM > SimTele.mEngineMaxRPM Then ' mEngineMaxRPM is 0 if in AI mode!
                ShiftUp = True
            Else
                ShiftUp = False
            End If

            If (SimTele.mEngineRPM / SimTele.mEngineMaxRPM < 0.2) Then ' mEngineMaxRPM is 0 if in AI mode!
                ShiftDown = True
            Else
                ShiftDown = False
            End If

            If CBool((SimTele.mWheel(0).mFlat Or SimTele.mWheel(1).mFlat Or SimTele.mWheel(2).mFlat Or SimTele.mWheel(3).mFlat)) Then
                TireDamage = True
            Else
                TireDamage = False
            End If

            If (SimTele.mWheel(0).mBrakeTemp > 1000 Or SimTele.mWheel(1).mBrakeTemp > 1000 Or SimTele.mWheel(2).mBrakeTemp > 1000 Or SimTele.mWheel(3).mBrakeTemp > 1000) Then 'assuming that 650°C is the optimal braking temp while > 1'000° is too much
                BrakeOverheat = True
            Else
                BrakeOverheat = False
            End If

            Dash_1_Output = "Speed [m/s]," & Int(speed + 0.5)
            Dash_2_Output = "RPM," & Int(SimTele.mEngineRPM + 0.5)
            Dash_3_Output = "Gear (-1 = Reverse)," & SimTele.mGear
            Dash_4_Output = "EngineWaterTemp [°C]," & SimTele.mEngineWaterTemp
            Dash_5_Output = "EngineOilTemp [°C]," & SimTele.mEngineOilTemp
            Dash_6_Output = "Fuel [lt]," & SimTele.mFuel
            'Dash_X_Output = "Fuel [%]," & SimToolsInfoData.SimTele.mFuelperCent only available in rFactor2
            Dash_7_Output = "Engine Overheating," & SimTele.mOverheating
            Dash_8_Output = "Brake Overheating," & BrakeOverheat
            Dash_9_Output = "TireDamage," & TireDamage
            'Dash_X_Output = "Headlights," & SimToolsInfoData.SimTele.mHeadlights only available in rFactor2
            Dash_10_Output = "ShiftUp," & ShiftUp  ' shift up light
            Dash_11_Output = "ShiftDown," & ShiftDown  'shift down light
            Dash_12_Output = "PartsDetached," & SimTele.mDetached
            Dash_13_Output = "InPit," & vehicleScore.mInPits
            Dash_14_Output = "YellowFlagState," & SimScoring.mYellowFlagState
            Dash_15_Output = "GamePhase," & SimScoring.mGamePhase
            Dash_16_Output = "Flags 1. Sector," & SimScoring.mSectorFlag(1)
            Dash_17_Output = "Flags 2. Sector," & SimScoring.mSectorFlag(2)
            Dash_18_Output = "Flags 3. Sector," & SimScoring.mSectorFlag(0)
            'Dash_20_Output = "Frequency," & Int(10000000.0 / CDbl(Now.Ticks - OldTime.Ticks) + 0.5)
            OldTime = Now
        Catch ex As Exception
        End Try

    End Sub

    ' constants
    'Public Const SHARED_MEM_SIZE = 72
    'Private
    'Private bytes(SHARED_MEM_SIZE) As Byte

    '################################################################################
    '-------------------------------rFactor Structures-------------------------------
    '↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓↓
    <StructLayout(LayoutKind.Sequential)> _
     Public Structure TelemVect3
        Public x, y, z As Single
    End Structure

    <StructLayout(LayoutKind.Sequential)> _
    Public Structure TelemWheelV2 ': Public TelemWheel
        'ADDITIONAL rFACTOR PLUGIN STRUCT TelemWheel
        Public mRotation As Single               ' radians/sec
        Public mSuspensionDeflection As Single   ' meters
        Public mRideHeight As Single             ' meters
        Public mTireLoad As Single               ' Newtons
        Public mLateralForce As Single           ' Newtons
        Public mGripFract As Single              ' an approximation of what fraction of the contact patch is sliding
        Public mBrakeTemp As Single              ' Celsius
        Public mPressure As Single               ' kPa
        <MarshalAs(UnmanagedType.ByValArray, sizeconst:=3)> _
        Public mTemperature() As Single          ' Celsius, left/center/right (not to be confused with inside/center/outside!)

        'ORIGINAL rFACTOR PLUGIN STRUCT TelemWheelV2
        Public mWear As Single                   ' wear (0.0-1.0, fraction of maximum) ... this is not necessarily proportional with grip loss
        <MarshalAs(UnmanagedType.ByValTStr, sizeconst:=16)> _
        Public mTerrainName As String            ' the material prefixes from the TDF file
        Public mSurfaceType As Byte              ' 0=dry, 1=wet, 2=grass, 3=dirt, 4=gravel, 5=rumblestrip
        Public mFlat As Byte                     ' whether tire is flat
        Public mDetached As Byte                 ' whether wheel is detached

        ' Future use
        <MarshalAs(UnmanagedType.ByValTStr, sizeconst:=32)> _
        Public mExpansion As String
    End Structure


    ' Our world coordinate system is left-handed, with +y pointing up.
    ' The local vehicle coordinate system is as follows:
    '   +x points out the left side of the car (from the driver's perspective)
    '   +y points out the roof
    '   +z points out the back of the car
    ' Rotations are as follows:
    '   +x pitches up
    '   +y yaws to the right
    '   +z rolls to the right


    '<StructLayout(LayoutKind.Sequential)> _
    Public Structure TelemInfoV2 ': Public TelemInfoBase ' for noobs: TelemInfoV2 contains everything in TelemInfoBase, plus the following:

        'ADDITIONAL rFACTOR PLUGIN STRUCT TelemInfoBase
        ' Time
        Public mDeltaTime As Single              ' time since last update (seconds)
        Public mLapNumber As Int32               ' current lap number
        Public mLapStartET As Single             ' time this lap was started
        <MarshalAs(UnmanagedType.ByValTStr, sizeconst:=64)> _
        Public mVehicleName As String            ' current vehicle name
        <MarshalAs(UnmanagedType.ByValTStr, sizeconst:=64)> _
        Public mTrackName As String              ' current track name

        ' Position and derivatives
        Public mPos As TelemVect3                ' world position in meters
        Public mLocalVel As TelemVect3           ' velocity (meters/sec) in local vehicle coordinates
        Public mLocalAccel As TelemVect3          ' acceleration (meters/sec^2) in local vehicle coordinates

        ' Orientation and derivatives
        Public mOriX As TelemVect3               ' top row of orientation matrix (also converts local vehicle vectors into world X using dot product)
        Public mOriY As TelemVect3               ' mid row of orientation matrix (also converts local vehicle vectors into world Y using dot product)
        Public mOriZ As TelemVect3               ' bot row of orientation matrix (also converts local vehicle vectors into world Z using dot product)
        Public mLocalRot As TelemVect3           ' rotation (radians/sec) in local vehicle coordinates
        Public mLocalRotAccel As TelemVect3      ' rotational acceleration (radians/sec^2) in local vehicle coordinates

        ' Vehicle status
        Public mGear As Int32                    ' -1=reverse, 0=neutral, 1+=forward gears
        Public mEngineRPM As Single              ' engine RPM
        Public mEngineWaterTemp As Single        ' Celsius
        Public mEngineOilTemp As Single          ' Celsius
        Public mClutchRPM As Single              ' clutch RPM

        ' Driver input
        Public mUnfilteredThrottle As Single     ' ranges  0.0-1.0
        Public mUnfilteredBrake As Single        ' ranges  0.0-1.0
        Public mUnfilteredSteering As Single     ' ranges -1.0-1.0 (left to right)
        Public mUnfilteredClutch As Single       ' ranges  0.0-1.0

        ' Misc
        Public mSteeringArmForce As Single       ' force on steering arms

        'ORIGINAL rFACTOR PLUGIN STRUCT TelemInfoV2
        ' state/damage info
        Public mFuel As Single                   ' amount of fuel (liters)
        Public mEngineMaxRPM As Single           ' rev limit, mEngineMaxRPM is 0 if in AI mode!
        Public mScheduledStops As Byte ' number of scheduled pitstops
        Public mOverheating As Byte              ' whether overheating icon is shown
        Public mDetached As Byte                 ' whether any parts (besides wheels) have been detached
        <MarshalAs(UnmanagedType.ByValArray, sizeconst:=8)> _
        Public mDentSeverity() As Byte ' dent severity at 8 locations around the car (0=none, 1=some, 2=more)
        Public mLastImpactET As Single           ' time of last impact
        Public mLastImpactMagnitude As Single    ' magnitude of last impact
        Public mLastImpactPos As TelemVect3      ' location of last impact

        ' Future use
        <MarshalAs(UnmanagedType.ByValArray, sizeconst:=64)> _
        Public mExpansion() As Byte

        ' keeping this at the end of the structure to make it easier to replace in future versions
        <MarshalAs(UnmanagedType.ByValArray, sizeconst:=4)> _
        Public mWheel() As TelemWheelV2          ' wheel info (front left, front right, rear left, rear right)
    End Structure

    <StructLayout(LayoutKind.Sequential)> _
    Public Structure VehicleScoringInfoV2 ': Public VehicleScoringInfo ' for noobs: VehicleScoringInfoV2 contains everything in VehicleScoringInfo, plus the following:
        'ADDITIONAL rFACTOR PLUGIN STRUCT VehicleScoringInfo
        <MarshalAs(UnmanagedType.ByValTStr, sizeconst:=32)> _
        Public mDriverName As String             ' driver name
        <MarshalAs(UnmanagedType.ByValTStr, sizeconst:=64)> _
        Public mVehicleName As String            ' vehicle name
        Public mTotalLaps As Int16               ' laps completed
        Public mSector As Byte                   ' 0=sector3, 1=sector1, 2=sector2 (don't ask why)
        Public mFinishStatus As Byte             ' 0=none, 1=finished, 2=dnf, 3=dq
        Public mLapDist As Single                ' current distance around track
        Public mPathLateral As Single            ' lateral position with respect to *very approximate* "center" path
        Public mTrackEdge As Single              ' track edge (w.r.t. "center" path) on same side of track as vehicle

        Public mBestSector1 As Single            ' best sector 1
        Public mBestSector2 As Single            ' best sector 2 (plus sector 1)
        Public mBestLapTime As Single            ' best lap time
        Public mLastSector1 As Single            ' last sector 1
        Public mLastSector2 As Single            ' last sector 2 (plus sector 1)
        Public mLastLapTime As Single            ' last lap time
        Public mCurSector1 As Single             ' current sector 1 if valid
        Public mCurSector2 As Single             ' current sector 2 (plus sector 1) if valid
        ' no current laptime because it instantly becomes "last"

        Public mNumPitstops As Int16             ' number of pitstops made
        Public mNumPenalties As Int16            ' number of outstanding penalties

        'ORIGINAL rFACTOR PLUGIN STRUCT VehicleScoringInfoV2
        Public mIsPlayer As Byte                 ' is this the player's vehicle
        Public mControl As Byte                  ' who's in control: -1=nobody (shouldn't get this), 0=local player, 1=local AI, 2=remote, 3=replay (shouldn't get this)
        Public mInPits As Byte                   ' between pit entrance and pit exit (not always accurate for remote vehicles)
        Public mPlace As Byte                    ' 1-based position
        <MarshalAs(UnmanagedType.ByValTStr, sizeconst:=32)> _
        Public mVehicleClass As String           ' vehicle class

        ' Dash Indicators
        Public mTimeBehindNext As Single          ' time behind vehicle in next higher place
        Public mLapsBehindNext As Int32           ' laps behind vehicle in next higher place
        Public mTimeBehindLeader As Single        ' time behind leader
        Public mLapsBehindLeader As Int32         ' laps behind leader
        Public mLapStartET As Single              ' time this lap was started

        ' Position and derivatives
        Public mPos As TelemVect3                 ' world position in meters
        Public mLocalVel As TelemVect3            ' velocity (meters/sec) in local vehicle coordinates
        Public mLocalAccel As TelemVect3          ' acceleration (meters/sec^2) in local vehicle coordinates

        ' Orientation and derivatives
        Public mOriX As TelemVect3                ' top row of orientation matrix (also converts local vehicle vectors into world X using dot product)
        Public mOriY As TelemVect3                ' mid row of orientation matrix (also converts local vehicle vectors into world Y using dot product)
        Public mOriZ As TelemVect3                ' bot row of orientation matrix (also converts local vehicle vectors into world Z using dot product)
        Public mLocalRot As TelemVect3            ' rotation (radians/sec) in local vehicle coordinates
        Public mLocalRotAccel As TelemVect3       ' rotational acceleration (radians/sec^2) in local vehicle coordinates

        ' Future use
        <MarshalAs(UnmanagedType.ByValTStr, sizeconst:=128)> _
        Public mExpansion As String
    End Structure

    <StructLayout(LayoutKind.Sequential)> _
    Public Structure ScoringInfoV2 ': Public ScoringInfoBase ' for noobs: ScoringInfoV2 contains everything in ScoringInfoBase, plus the following:
        'ADDITIONAL rFACTOR PLUGIN STRUCT ScoringInfoBase
        <MarshalAs(UnmanagedType.ByValTStr, sizeconst:=64)> _
        Public mTrackName As String               ' current track name
        Public mSession As Int32                  ' current session
        Public mCurrentET As Single               ' current time
        Public mEndET As Single                   ' ending time
        Public mMaxLaps As Int32                  ' maximum laps
        Public mLapDist As Single                 ' distance around track
        Public mResultsStream As Int32            ' Not Implemented: results stream additions since last update (newline-delimited and NULL-terminated)
        Public mNumVehicles As Int32              ' current number of vehicles

        'ORIGINAL rFACTOR PLUGIN STRUCT ScoringInfoV2
        ' Game phases:
        ' 0 Before session has begun
        ' 1 Reconnaissance laps (race only)
        ' 2 Grid walk-through (race only)
        ' 3 Formation lap (race only)
        ' 4 Starting-light countdown has begun (race only)
        ' 5 Green flag
        ' 6 Full course yellow / safety car
        ' 7 Session stopped
        ' 8 Session over
        Public mGamePhase As Byte

        ' Yellow flag states (applies to full-course only)
        ' -1 Invalid
        '  0 None
        '  1 Pending
        '  2 Pits closed
        '  3 Pit lead lap
        '  4 Pits open
        '  5 Last lap
        '  6 Resume
        '  7 Race halt (not currently used)
        Public mYellowFlagState As Byte

        <MarshalAs(UnmanagedType.ByValArray, sizeconst:=3)> _
        Public mSectorFlag() As Byte              ' whether there are any local yellows at the moment in each sector (not sure if sector 0 is first or last, so test)
        Public mStartLight As Byte                ' start light frame (number depends on track)
        Public mNumRedLights As Byte              ' number of red lights in start sequence
        Public mInRealtime As Byte                ' in realtime as opposed to at the monitor
        <MarshalAs(UnmanagedType.ByValTStr, sizeconst:=32)> _
        Public mPlayerName As String              ' player name (including possible multiplayer override)
        <MarshalAs(UnmanagedType.ByValTStr, sizeconst:=64)> _
        Public mPlrFileName As String             ' may be encoded to be a legal filename

        ' weather
        Public mDarkCloud As Single               ' cloud darkness? 0.0-1.0
        Public mRaining As Single                 ' raining severity 0.0-1.0
        Public mAmbientTemp As Single             ' temperature (Celsius)
        Public mTrackTemp As Single               ' temperature (Celsius)
        Public mWind As TelemVect3                ' wind speed
        Public mOnPathWetness As Single           ' on main path 0.0-1.0
        Public mOffPathWetness As Single          ' on main path 0.0-1.0

        ' Future use
        <MarshalAs(UnmanagedType.ByValTStr, sizeconst:=256)> _
        Public mExpansion As String

        ' keeping this at the end of the structure to make it easier to replace in future versions
        'Public mVehicle As VehicleScoringInfoV2  ' array of vehicle scoring info's
        Public mVehicleDummy As Int32              'Not valid: As VehicleScoringInfoV2 is transfered via the MMF
    End Structure

    '↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑↑
    '-------------------------------rFactor Structures-------------------------------
    '################################################################################

    'Used by GameEngine to Process Incoming UDP Packets.
    Private Input_Data As New GenericOutput
    Sub Process_PacketRecieved(Text As String) Implements IPlugin.Process_PacketRecieved
        'DO SOMETHING HERE TO RECIEVED UDP PACKETS
        Input_Data = CType(DeSerializeString(Text), GenericOutput)
        'Get Proper Data out of UDP Packet
        With Input_Data
            Roll_Output = (._Roll)
            Pitch_Output = (._Pitch)
            Heave_Output = (._Heave)
            Yaw_Output = (._Yaw)
            Sway_Output = (._Sway)
            Surge_Output = (._Surge)
            Extra1_Output = ._Extra3
        End With
    End Sub

    'Used by GameManager to Patch a Game.
    Function PatchGame(ByVal MyPath As String, ByVal MyIp As String) As Boolean Implements IPlugin.PatchGame
        Try
            UnPatch(MyPath)
            IO.File.SetAttributes(MyPath & "Plugins", FileAttributes.Normal)
            IO.File.WriteAllBytes(MyPath & "Plugins\SimTools_rFactor.dll", My.Resources.SimTools_rFactor)
            MsgBox("Patch Installed!", MsgBoxStyle.OkOnly, "Patching info")
            Return True
        Catch ex As Exception
            Return False
        End Try
    End Function

    'Used by GameManager to UnPatch a Game.
    Sub UnPatchGame(MyPath As String) Implements IPlugin.UnPatchGame
        UnPatch(MyPath)
        MsgBox("Patch Uninstalled!", MsgBoxStyle.OkOnly, "Patching info")
    End Sub

    Private Sub UnPatch(MyPath As String)
        If IO.File.Exists(MyPath & "Plugins\SimTools_rFactor.dll") = True Then
            IO.File.Delete(MyPath & "Plugins\SimTools_rFactor.dll")
        End If
    End Sub

    Sub PatchPathInfo() Implements IPlugin.PatchPathInfo
        MsgBox("Please Select the rFactors's Installation Directory.", MsgBoxStyle.OkOnly, "Patching info")
    End Sub

    'Used by GameManager to Validate a Path befors Patching.
    Function ValidatePatchPath(MyPath As String) As Boolean Implements IPlugin.ValidatePatchPath
        'CHANGE AS NEEDED TO VALIDATE GAME
        'let the user know he/she got it right - Game Instalation Folder is always the target for the user!!!
        'example
        If System.IO.File.Exists(MyPath & "\rFactor.exe") = True Then
            Return True
        Else
            Return False
        End If
    End Function


    '//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    '///                                                        DO NOT EDIT BELOW HERE!!!                                                           ///
    '//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#Region "///// BUILT IN METHODS - DO NOT CHANGE /////"
    'For MemoryHook
    Public Declare Function ReadProcessMemory Lib "kernel32" Alias "ReadProcessMemory" (ByVal hProcess As Integer, ByVal lpBaseAddress As Integer, ByVal lpBuffer() As Byte, ByVal nSize As Integer, ByRef lpNumberOfBytesWritten As Integer) As Integer
    Public Declare Function CloseHandle Lib "kernel32" Alias "CloseHandle" (ByVal hObject As Integer) As Integer
    Public Declare Function OpenProcess Lib "kernel32" Alias "OpenProcess" (ByVal dwDesiredAccess As Integer, ByVal bInheritHandle As Integer, ByVal dwProcessId As Integer) As Integer

    'Output Dash Vars
    Public Dash_1_Output As String = ""
    Public Dash_2_Output As String = ""
    Public Dash_3_Output As String = ""
    Public Dash_4_Output As String = ""
    Public Dash_5_Output As String = ""
    Public Dash_6_Output As String = ""
    Public Dash_7_Output As String = ""
    Public Dash_8_Output As String = ""
    Public Dash_9_Output As String = ""
    Public Dash_10_Output As String = ""
    Public Dash_11_Output As String = ""
    Public Dash_12_Output As String = ""
    Public Dash_13_Output As String = ""
    Public Dash_14_Output As String = ""
    Public Dash_15_Output As String = ""
    Public Dash_16_Output As String = ""
    Public Dash_17_Output As String = ""
    Public Dash_18_Output As String = ""
    Public Dash_19_Output As String = ""
    Public Dash_20_Output As String = ""

    'Output Vars
    Public Roll_Output As Double = 0
    Public Pitch_Output As Double = 0
    Public Heave_Output As Double = 0
    Public Yaw_Output As Double = 0
    Public Sway_Output As Double = 0
    Public Surge_Output As Double = 0
    Public Extra1_Output As Double = 0
    Public Extra2_Output As Double = 0
    Public Extra3_Output As Double = 0

    'MemHook Vars
    Public Roll_MemHook As Double = 0
    Public Pitch_MemHook As Double = 0
    Public Heave_MemHook As Double = 0
    Public Yaw_MemHook As Double = 0
    Public Sway_MemHook As Double = 0
    Public Surge_MemHook As Double = 0
    Public Extra1_MemHook As Double = 0
    Public Extra2_MemHook As Double = 0
    Public Extra3_MemHook As Double = 0

    'MemMap Vars
    Public Roll_MemMap As Double = 0
    Public Pitch_MemMap As Double = 0
    Public Heave_MemMap As Double = 0
    Public Yaw_MemMap As Double = 0
    Public Sway_MemMap As Double = 0
    Public Surge_MemMap As Double = 0
    Public Extra1_MemMap As Double = 0
    Public Extra2_MemMap As Double = 0
    Public Extra3_MemMap As Double = 0

    Public Function GetDOFsUsed() As String Implements IPlugin.GetDOFsUsed
        'Return DOF's Used (Roll,Pitch,Heave,Yaw,Sway,Surge)
        Return (_DOF_Support_Roll.ToString & "," & _DOF_Support_Pitch.ToString & "," & _DOF_Support_Heave.ToString & "," & _DOF_Support_Yaw.ToString & "," & _DOF_Support_Sway.ToString & "," & _DOF_Support_Surge.ToString & "," & _DOF_Support_Extra1.ToString & "," & _DOF_Support_Extra2.ToString & "," & _DOF_Support_Extra3.ToString)
    End Function

    Public Sub ResetDOFVars() Implements IPlugin.ResetDOFVars
        Roll_Output = 0
        Pitch_Output = 0
        Heave_Output = 0
        Yaw_Output = 0
        Sway_Output = 0
        Surge_Output = 0
        Extra1_Output = 0
        Extra2_Output = 0
        Extra3_Output = 0
    End Sub

    Public Sub ResetMapVars() Implements IPlugin.ResetMapVars
        Roll_MemMap = 0
        Pitch_MemMap = 0
        Heave_MemMap = 0
        Yaw_MemMap = 0
        Sway_MemMap = 0
        Surge_MemMap = 0
        Extra1_MemMap = 0
        Extra2_MemMap = 0
        Extra3_MemMap = 0
    End Sub

    Public Sub ResetHookVars() Implements IPlugin.ResetHookVars
        Roll_MemHook = 0
        Pitch_MemHook = 0
        Heave_MemHook = 0
        Yaw_MemHook = 0
        Sway_MemHook = 0
        Surge_MemHook = 0
        Extra1_MemHook = 0
        Extra2_MemHook = 0
        Extra3_MemHook = 0
    End Sub

    Public Sub ResetDashVars() Implements IPlugin.ResetDashVars
        Dash_1_Output = ""
        Dash_2_Output = ""
        Dash_3_Output = ""
        Dash_4_Output = ""
        Dash_5_Output = ""
        Dash_6_Output = ""
        Dash_7_Output = ""
        Dash_8_Output = ""
        Dash_9_Output = ""
        Dash_10_Output = ""
        Dash_11_Output = ""
        Dash_12_Output = ""
        Dash_13_Output = ""
        Dash_14_Output = ""
        Dash_15_Output = ""
        Dash_16_Output = ""
        Dash_17_Output = ""
        Dash_18_Output = ""
        Dash_19_Output = ""
        Dash_20_Output = ""
    End Sub

    Public ReadOnly Property PluginAuthorsName() As String Implements IPlugin.PluginAuthorsName
        Get
            Return _PluginAuthorsName
        End Get
    End Property

    Public ReadOnly Property Name() As String Implements IPlugin.Name
        Get
            Return _GameName
        End Get
    End Property

    Public ReadOnly Property ProcessName() As String Implements IPlugin.ProcessName
        Get
            Return _ProcessName
        End Get
    End Property

    Public ReadOnly Property Port() As String Implements IPlugin.Port
        Get
            Return _Port
        End Get
    End Property

    Public ReadOnly Property Is_MemoryMap() As Boolean Implements IPlugin.Is_MemoryMap
        Get
            Return _Is_MemoryMap
        End Get
    End Property

    Public ReadOnly Property Is_MemoryHook() As Boolean Implements IPlugin.Is_MemoryHook
        Get
            Return _Is_MemoryHook
        End Get
    End Property

    Public ReadOnly Property Is_DashBoard() As Boolean Implements IPlugin.Is_DashBoard
        Get
            Return _Is_DashBoard
        End Get
    End Property

    Public Function Get_RollOutput() As Double Implements IPlugin.Get_RollOutput
        Return Roll_Output
    End Function

    Public Function Get_Dash_1_Output() As String Implements IPlugin.Get_Dash1_Output
        Return Dash_1_Output
    End Function


    Public Function Get_Dash_2_Output() As String Implements IPlugin.Get_Dash2_Output
        Return Dash_2_Output
    End Function


    Public Function Get_Dash_3_Output() As String Implements IPlugin.Get_Dash3_Output
        Return Dash_3_Output
    End Function


    Public Function Get_Dash_4_Output() As String Implements IPlugin.Get_Dash4_Output
        Return Dash_4_Output
    End Function


    Public Function Get_Dash_5_Output() As String Implements IPlugin.Get_Dash5_Output
        Return Dash_5_Output
    End Function


    Public Function Get_Dash_6_Output() As String Implements IPlugin.Get_Dash6_Output
        Return Dash_6_Output
    End Function


    Public Function Get_Dash_7_Output() As String Implements IPlugin.Get_Dash7_Output
        Return Dash_7_Output
    End Function


    Public Function Get_Dash_8_Output() As String Implements IPlugin.Get_Dash8_Output
        Return Dash_8_Output
    End Function


    Public Function Get_Dash_9_Output() As String Implements IPlugin.Get_Dash9_Output
        Return Dash_9_Output
    End Function


    Public Function Get_Dash_10_Output() As String Implements IPlugin.Get_Dash10_Output
        Return Dash_10_Output
    End Function


    Public Function Get_Dash_11_Output() As String Implements IPlugin.Get_Dash11_Output
        Return Dash_11_Output
    End Function


    Public Function Get_Dash_12_Output() As String Implements IPlugin.Get_Dash12_Output
        Return Dash_12_Output
    End Function


    Public Function Get_Dash_13_Output() As String Implements IPlugin.Get_Dash13_Output
        Return Dash_13_Output
    End Function


    Public Function Get_Dash_14_Output() As String Implements IPlugin.Get_Dash14_Output
        Return Dash_14_Output
    End Function


    Public Function Get_Dash_15_Output() As String Implements IPlugin.Get_Dash15_Output
        Return Dash_15_Output
    End Function


    Public Function Get_Dash_16_Output() As String Implements IPlugin.Get_Dash16_Output
        Return Dash_16_Output
    End Function


    Public Function Get_Dash_17_Output() As String Implements IPlugin.Get_Dash17_Output
        Return Dash_17_Output
    End Function


    Public Function Get_Dash_18_Output() As String Implements IPlugin.Get_Dash18_Output
        Return Dash_18_Output
    End Function


    Public Function Get_Dash_19_Output() As String Implements IPlugin.Get_Dash19_Output
        Return Dash_19_Output
    End Function


    Public Function Get_Dash_20_Output() As String Implements IPlugin.Get_Dash20_Output
        Return Dash_20_Output
    End Function


    Public Function Get_PitchOutput() As Double Implements IPlugin.Get_PitchOutput
        Return Pitch_Output
    End Function

    Public Function Get_HeaveOutput() As Double Implements IPlugin.Get_HeaveOutput
        Return Heave_Output
    End Function

    Public Function Get_YawOutput() As Double Implements IPlugin.Get_YawOutput
        Return Yaw_Output
    End Function

    Public Function Get_SwayOutput() As Double Implements IPlugin.Get_SwayOutput
        Return Sway_Output
    End Function

    Public Function Get_SurgeOutput() As Double Implements IPlugin.Get_SurgeOutput
        Return Surge_Output
    End Function

    Public Function Get_Extra1Output() As Double Implements IPlugin.Get_Extra1Output
        Return Extra1_Output
    End Function

    Public Function Get_Extra2Output() As Double Implements IPlugin.Get_Extra2Output
        Return Extra2_Output
    End Function

    Public Function Get_Extra3Output() As Double Implements IPlugin.Get_Extra3Output
        Return Extra3_Output
    End Function

    Public Function Get_RollMemHook() As Double Implements IPlugin.Get_RollMemHook
        Return Roll_MemHook
    End Function

    Public Function Get_PitchMemHook() As Double Implements IPlugin.Get_PitchMemHook
        Return Pitch_MemHook
    End Function

    Public Function Get_HeaveMemHook() As Double Implements IPlugin.Get_HeaveMemHook
        Return Heave_MemHook
    End Function

    Public Function Get_YawMemHook() As Double Implements IPlugin.Get_YawMemHook
        Return Yaw_MemHook
    End Function

    Public Function Get_SwayMemHook() As Double Implements IPlugin.Get_SwayMemHook
        Return Sway_MemHook
    End Function

    Public Function Get_SurgeMemHook() As Double Implements IPlugin.Get_SurgeMemHook
        Return Surge_MemHook
    End Function

    Public Function Get_Extra1MemHook() As Double Implements IPlugin.Get_Extra1MemHook
        Return Extra1_MemHook
    End Function

    Public Function Get_Extra2MemHook() As Double Implements IPlugin.Get_Extra2MemHook
        Return Extra2_MemHook
    End Function

    Public Function Get_Extra3MemHook() As Double Implements IPlugin.Get_Extra3MemHook
        Return Extra3_MemHook
    End Function

    Public Function Get_RollMemMap() As Double Implements IPlugin.Get_RollMemMap
        Return Roll_MemMap
    End Function

    Public Function Get_PitchMemMap() As Double Implements IPlugin.Get_PitchMemMap
        Return Pitch_MemMap
    End Function

    Public Function Get_HeaveMemMap() As Double Implements IPlugin.Get_HeaveMemMap
        Return Heave_MemMap
    End Function

    Public Function Get_YawMemMap() As Double Implements IPlugin.Get_YawMemMap
        Return Yaw_MemMap
    End Function

    Public Function Get_SwayMemMap() As Double Implements IPlugin.Get_SwayMemMap
        Return Sway_MemMap
    End Function

    Public Function Get_SurgeMemMap() As Double Implements IPlugin.Get_SurgeMemMap
        Return Surge_MemMap
    End Function

    Public Function Get_Extra1MemMap() As Double Implements IPlugin.Get_Extra1MemMap
        Return Extra1_MemMap
    End Function

    Public Function Get_Extra2MemMap() As Double Implements IPlugin.Get_Extra2MemMap
        Return Extra2_MemMap
    End Function

    Public Function Get_Extra3MemMap() As Double Implements IPlugin.Get_Extra3MemMap
        Return Extra3_MemMap
    End Function

    'File Editor - Replaces a line in a txt/cfg file
    Private Sub MyFileEditor(FileName As String, LinetoEdit As String, StingReplacment As String)
        Dim lines As New List(Of String)
        Dim x As Integer = 0
        Using sr As New System.IO.StreamReader(FileName)
            While Not sr.EndOfStream
                lines.Add(sr.ReadLine)
            End While
        End Using

        For Each line As String In lines
            If line.Contains(LinetoEdit) Then
                lines.RemoveAt(x)
                lines.Insert(x, StingReplacment)
                Exit For 'must exit as we changed the iteration   
            End If
            x = x + 1
        Next

        Using sw As New System.IO.StreamWriter(FileName)
            For Each line As String In lines
                sw.WriteLine(line)
            Next
        End Using
        lines.Clear()
    End Sub

    'DeSerialize
    Public Function DeSerializeString(InputString As String) As Object
        On Error Resume Next
        Dim xml_serializer As New XmlSerializer(GetType(GenericOutput))
        Dim string_reader As New StringReader(InputString)
        Dim DeserializedOutput As GenericOutput = DirectCast(xml_serializer.Deserialize(string_reader), GenericOutput)
        string_reader.Close()
        Return DeserializedOutput
    End Function

    'Generic In/Output structure
    Public Structure GenericOutput
        Public _Roll As Double
        Public _Pitch As Double
        Public _Heave As Double
        Public _Yaw As Double
        Public _Sway As Double
        Public _Surge As Double
        Public _Extra1 As Double
        Public _Extra2 As Double
        Public _Extra3 As Double
    End Structure

    'memory hook function #1
    Public Function ReadSingle(hProcess As String, dwAddress As UInteger) As String
        Try
            Dim proc As Process = Process.GetProcessesByName(hProcess)(0)
            Dim winhandle As Integer = CInt(CType(OpenProcess(&H1F0FFF, 1, proc.Id), IntPtr))
            Dim buffer As Byte() = New Byte(3) {}
            buffer.ToArray()
            ReadProcessMemory(winhandle, CInt(dwAddress), buffer, 4, 0)
            Dim MySingle As Single = BitConverter.ToSingle(buffer, 0)
            Return MySingle.ToString
        Catch ex As Exception
            Return Nothing
        End Try
    End Function

    'memory hook function #2
    Public Function ReadInt32(hProcess As String, dwAddress As UInteger) As String
        Try
            Dim proc As Process = Process.GetProcessesByName(hProcess)(0)
            Dim winhandle As Integer = CInt(CType(OpenProcess(&H1F0FFF, 1, proc.Id), IntPtr))
            Dim buffer As Byte() = New Byte(3) {}
            buffer.ToArray()
            ReadProcessMemory(winhandle, CInt(dwAddress), buffer, 4, 0)
            Dim MyInt32 As Integer = BitConverter.ToInt32(buffer, 0)
            Return MyInt32.ToString
        Catch ex As Exception
            Return Nothing
        End Try
    End Function
#End Region
End Class
